;////////////////////////////////////////////
;///  Petezl 2005  //////////////////////////
;///  Example of using a pen in a Static  ///
;///  control, in a window //////////////////
;///  it was wrote from scratch so it no ////
;///  doubt could be improved  //////////////
;////////////////////////////////////////////

.386 
.model flat,stdcall 
option casemap:none 
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD 

include \masm32\include\windows.inc 
include \masm32\include\user32.inc 
include \masm32\include\kernel32.inc 
includelib \masm32\lib\user32.lib 
includelib \masm32\lib\kernel32.lib 

include \masm32\include\gdi32.inc  ;// You need these two
includelib \masm32\lib\gdi32.lib 

.data 
ClassName db "Petezl_WinClass",0 
AppName db "Pen in a window",0 
StaticID1 dd 4001
StaticClassName db "Static",0

.data? 
hInstance HINSTANCE ? 
CommandLine LPSTR ? 
hwndStatic1 HWND ?

hbluePen dd ?
hredPen  dd ?
holdPen  dd ?

.code 
start: 
invoke GetModuleHandle, NULL 
mov hInstance,eax 
invoke GetCommandLine
mov CommandLine,eax 
invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT 
invoke ExitProcess,eax 

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD 
LOCAL wc:WNDCLASSEX 
LOCAL msg:MSG 
LOCAL hwnd:HWND 
mov wc.cbSize,SIZEOF WNDCLASSEX 
mov wc.style, CS_HREDRAW or CS_VREDRAW 
mov wc.lpfnWndProc, OFFSET WndProc 
mov wc.cbClsExtra,NULL 
mov wc.cbWndExtra,NULL 
push hInst 
pop wc.hInstance 
mov wc.hbrBackground,COLOR_WINDOW+2                         ;// Color the window Black
mov wc.lpszMenuName, 0h 
mov wc.lpszClassName,OFFSET ClassName 
invoke LoadIcon,NULL,IDI_APPLICATION 
mov wc.hIcon,eax 
mov wc.hIconSm,eax 
invoke LoadCursor,NULL,IDC_ARROW 
mov wc.hCursor,eax 
invoke RegisterClassEx, addr wc 
invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName, \    ;// create a fixed size window
ADDR AppName, WS_SYSMENU + WS_MINIMIZEBOX,\ 
CW_USEDEFAULT, CW_USEDEFAULT,\ 
500,400,NULL,NULL, hInst,NULL
mov hwnd,eax 
invoke ShowWindow, hwnd,SW_SHOWNORMAL 
invoke UpdateWindow, hwnd 
.WHILE TRUE 
invoke GetMessage, ADDR msg,NULL,0,0 
.BREAK .IF (!eax) 
invoke TranslateMessage, ADDR msg 
invoke DispatchMessage, ADDR msg 
.ENDW 
mov eax,msg.wParam 
ret 
WinMain endp
; 

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM 

LOCAL ps:PAINTSTRUCT 
LOCAL hdc:HDC 
LOCAL rect:RECT

; 

;// Select default pen and delete all objects created, then quit

.IF uMsg==WM_DESTROY 
      invoke SelectObject, hdc, holdPen
      invoke DeleteObject, hredPen
      invoke DeleteObject, hbluePen
      invoke PostQuitMessage,NULL
; 

.elseif uMsg==WM_CREATE

;// Create the Static to accept drawing on: <SS_BITMAP> renders the static invisible
;// if no bitmap has been painted it, so have added <SS_SUNKEN> to show the edge and in WM_SIZE will
;// make it 50 pixels smaller than the client area

      invoke CreateWindowEx,NULL, ADDR StaticClassName,addr AppName,\
      WS_CHILD or WS_VISIBLE or SS_BITMAP or SS_SUNKEN, 0,0,0,0,hWnd,StaticID1,hInstance,NULL
      mov hwndStatic1,eax

;// Create all your pens, brushes etc

      invoke CreatePen,PS_SOLID,1, 000000ffh ;// Create a Red pen
      mov hredPen,eax 
      invoke CreatePen,PS_SOLID,1, 00ff0000h ;// Create a Blue pen
      mov hbluePen,eax 
      
;// select any pen, purpose: to save the default
;// there might be a better way to do this

      invoke SelectObject,hdc, hbluePen  
      mov holdPen,eax                     

.elseif uMsg==WM_PAINT 
        invoke BeginPaint,hwndStatic1,addr ps 
        mov hdc,eax
        
              invoke SelectObject,hdc, hbluePen
              invoke GetClientRect, hwndStatic1, addr rect
              invoke MoveToEx, hdc, rect.left, rect.top, NULL
              invoke LineTo, hdc, rect.right, rect.bottom
        
              invoke SelectObject, hdc, hredPen
              invoke MoveToEx, hdc, rect.left, rect.bottom, NULL
              invoke LineTo, hdc, rect.right, rect.top
        
        invoke EndPaint,hwndStatic1,addr ps 

; 

.elseif uMsg==WM_SIZE

;// Make the static window size 50 pixels less than the client area
;// this is just to show that the pen is drawing in that window and not the main
;// client area that is visible behind

;// this crap is just to make the Static 50 pixels smaller than the client area

		mov eax,lParam
            shr eax,16
            sub eax, 100
            mov edx, eax

		mov eax,lParam
            and eax,0ffffh
            sub eax, 100
            
            mov ecx, 50
		invoke MoveWindow,hwndStatic1,ecx,ecx,eax,edx,TRUE 
; 

.else 
invoke DefWindowProc,hWnd,uMsg,wParam,lParam 
ret 
.endif 
xor eax,eax 
ret 
WndProc endp 

end start 
